package cn.com.qmth.examcloud.core.oe.student.face.provider;


import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import cn.com.qmth.examcloud.core.oe.common.entity.ExamCaptureQueueEntity;
import cn.com.qmth.examcloud.core.oe.common.repository.ExamCaptureQueueRepo;
import cn.com.qmth.examcloud.core.oe.student.face.api.ExamCaptureQueueCloudService;
import cn.com.qmth.examcloud.core.oe.student.face.api.request.ExamCaptureQueueReq;
import cn.com.qmth.examcloud.core.oe.student.face.service.ExamCaptureQueueFailedService;
import cn.com.qmth.examcloud.core.oe.student.face.service.ExamCaptureQueueService;
import cn.com.qmth.examcloud.core.oe.student.face.service.ExamCaptureService;
import cn.com.qmth.examcloud.core.oe.student.face.service.bean.CallType;
import cn.com.qmth.examcloud.web.support.ControllerSupport;
import io.swagger.annotations.ApiOperation;


@RestController
@RequestMapping("${$rmp.cloud.oe.student.face}/examCaptureQueue")
public class ExamCaptureQueueProvider  extends ControllerSupport implements ExamCaptureQueueCloudService{

	/**
	 * 
	 */
	private static final long serialVersionUID = -4141691118761857199L;

	@Autowired
	private ExamCaptureQueueService examCaptureQueueService;
	
	@Autowired
	private ExamCaptureService examCaptureService;
	
	@Autowired
	private ExamCaptureQueueRepo examCaptureQueueRepo;
	
	@Autowired
	private ExamCaptureQueueFailedService examCaptureQueueFailedService;

	@Override
	@ApiOperation(value = "处理抓拍照片队列")
	@PostMapping("/processingExamCaptureQueue")
	public void processingExamCaptureQueue() {
//		examCaptureQueueService.processingExamCaptureQueue();
	}

	@Override
	@ApiOperation(value = "交卷阶段:根据examRecordDataId处理相关抓拍照片")
	@PostMapping("/disposeExamCapturePhoto")
	public void disposeExamCapturePhoto(@RequestBody ExamCaptureQueueReq examCaptureQueueReq) {
//		List<ExamCaptureQueueEntity> examCaptureQueueEntities = examCaptureQueueRepo.findByExamRecordDataId(examCaptureQueueReq.getExamRecordDataId());
//		for(ExamCaptureQueueEntity examCaptureQueueEntity:examCaptureQueueEntities){
//			examCaptureService.disposeExamCapture(examCaptureQueueEntity,CallType.SYNC);
//		}
	}

	@Override
	@ApiOperation(value = "将超过XX分钟，还在处理中的状态修改为未处理")
	@PostMapping("/changeExamCaptureQueueStatus")
	public void changeExamCaptureQueueStatus() {
		examCaptureQueueService.changeExamCaptureQueueStatus();
	}
	
	@Override
	@ApiOperation(value = "考试抓拍队列失败处理")
	@PostMapping("/examCaptureQueueFailedDispose")
	public void examCaptureQueueFailedDispose() throws Exception{
		examCaptureQueueFailedService.examCaptureQueueFailedDispose();
	}
}
